/* memory-buffer.c generated by valac 0.30.2, the Vala compiler
 * generated from memory-buffer.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define GEARY_TYPE_BASE_OBJECT (geary_base_object_get_type ())
#define GEARY_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObject))
#define GEARY_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))
#define GEARY_IS_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_OBJECT))
#define GEARY_IS_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_BASE_OBJECT))
#define GEARY_BASE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))

typedef struct _GearyBaseObject GearyBaseObject;
typedef struct _GearyBaseObjectClass GearyBaseObjectClass;
typedef struct _GearyBaseObjectPrivate GearyBaseObjectPrivate;

#define GEARY_MEMORY_TYPE_BUFFER (geary_memory_buffer_get_type ())
#define GEARY_MEMORY_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer))
#define GEARY_MEMORY_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBufferClass))
#define GEARY_MEMORY_IS_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MEMORY_TYPE_BUFFER))
#define GEARY_MEMORY_IS_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_MEMORY_TYPE_BUFFER))
#define GEARY_MEMORY_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBufferClass))

typedef struct _GearyMemoryBuffer GearyMemoryBuffer;
typedef struct _GearyMemoryBufferClass GearyMemoryBufferClass;
typedef struct _GearyMemoryBufferPrivate GearyMemoryBufferPrivate;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_byte_array_unref0(var) ((var == NULL) ? NULL : (var = (g_byte_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GearyBaseObject {
	GObject parent_instance;
	GearyBaseObjectPrivate * priv;
};

struct _GearyBaseObjectClass {
	GObjectClass parent_class;
};

struct _GearyMemoryBuffer {
	GearyBaseObject parent_instance;
	GearyMemoryBufferPrivate * priv;
};

struct _GearyMemoryBufferClass {
	GearyBaseObjectClass parent_class;
	GBytes* (*get_bytes) (GearyMemoryBuffer* self);
	GInputStream* (*get_input_stream) (GearyMemoryBuffer* self);
	GByteArray* (*get_byte_array) (GearyMemoryBuffer* self);
	guint8* (*get_uint8_array) (GearyMemoryBuffer* self, int* result_length1);
	gchar* (*to_string) (GearyMemoryBuffer* self);
	gchar* (*get_valid_utf8) (GearyMemoryBuffer* self);
	gsize (*get_size) (GearyMemoryBuffer* self);
	gsize (*get_allocated_size) (GearyMemoryBuffer* self);
};


static gpointer geary_memory_buffer_parent_class = NULL;

GType geary_base_object_get_type (void) G_GNUC_CONST;
GType geary_memory_buffer_get_type (void) G_GNUC_CONST;
enum  {
	GEARY_MEMORY_BUFFER_DUMMY_PROPERTY,
	GEARY_MEMORY_BUFFER_SIZE,
	GEARY_MEMORY_BUFFER_ALLOCATED_SIZE
};
GBytes* geary_memory_buffer_get_bytes (GearyMemoryBuffer* self);
static GBytes* geary_memory_buffer_real_get_bytes (GearyMemoryBuffer* self);
GInputStream* geary_memory_buffer_get_input_stream (GearyMemoryBuffer* self);
static GInputStream* geary_memory_buffer_real_get_input_stream (GearyMemoryBuffer* self);
GByteArray* geary_memory_buffer_get_byte_array (GearyMemoryBuffer* self);
static GByteArray* geary_memory_buffer_real_get_byte_array (GearyMemoryBuffer* self);
guint8* geary_memory_buffer_get_uint8_array (GearyMemoryBuffer* self, int* result_length1);
static guint8* geary_memory_buffer_real_get_uint8_array (GearyMemoryBuffer* self, int* result_length1);
static guint8* _vala_array_dup3 (guint8* self, int length);
gchar* geary_memory_buffer_to_string (GearyMemoryBuffer* self);
static gchar* geary_memory_buffer_real_to_string (GearyMemoryBuffer* self);
static void _vala_array_add14 (guint8** array, int* length, int* size, guint8 value);
gchar* geary_memory_buffer_get_valid_utf8 (GearyMemoryBuffer* self);
static gchar* geary_memory_buffer_real_get_valid_utf8 (GearyMemoryBuffer* self);
GearyMemoryBuffer* geary_memory_buffer_construct (GType object_type);
GearyBaseObject* geary_base_object_construct (GType object_type);
gsize geary_memory_buffer_get_size (GearyMemoryBuffer* self);
gsize geary_memory_buffer_get_allocated_size (GearyMemoryBuffer* self);
static void _vala_geary_memory_buffer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);


/**
     * Returns a Bytes object holding the buffer's contents.
     *
     * Since Bytes is immutable, the caller will need to make its own copy if it wants to modify
     * the data.
     */
static GBytes* geary_memory_buffer_real_get_bytes (GearyMemoryBuffer* self) {
#line 41 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_memory_buffer_get_bytes'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 41 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return NULL;
#line 111 "memory-buffer.c"
}


GBytes* geary_memory_buffer_get_bytes (GearyMemoryBuffer* self) {
#line 41 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), NULL);
#line 41 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return GEARY_MEMORY_BUFFER_GET_CLASS (self)->get_bytes (self);
#line 120 "memory-buffer.c"
}


/**
     * Returns an InputStream that can read the buffer in its current entirety.
     *
     * Note that the InputStream may share its memory buffer(s) with the Buffer but does
     * not hold references to them or the Buffer itself.  Thus, the Buffer should
     * only be destroyed after all InputStreams are destroyed or exhausted.
     *
     * The base class implementation uses {@link get_bytes} to create the InputStream.  Subclasses
     * should look for more optimal implementations.
     */
static GInputStream* geary_memory_buffer_real_get_input_stream (GearyMemoryBuffer* self) {
	GInputStream* result = NULL;
	GBytes* _tmp0_ = NULL;
	GBytes* _tmp1_ = NULL;
	GMemoryInputStream* _tmp2_ = NULL;
	GInputStream* _tmp3_ = NULL;
#line 54 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp0_ = geary_memory_buffer_get_bytes (self);
#line 54 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp1_ = _tmp0_;
#line 54 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp2_ = (GMemoryInputStream*) g_memory_input_stream_new_from_bytes (_tmp1_);
#line 54 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, G_TYPE_INPUT_STREAM, GInputStream);
#line 54 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_g_bytes_unref0 (_tmp1_);
#line 54 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	result = _tmp3_;
#line 54 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return result;
#line 154 "memory-buffer.c"
}


GInputStream* geary_memory_buffer_get_input_stream (GearyMemoryBuffer* self) {
#line 53 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), NULL);
#line 53 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return GEARY_MEMORY_BUFFER_GET_CLASS (self)->get_input_stream (self);
#line 163 "memory-buffer.c"
}


/**
     * Returns a ByteArray storing the buffer in its entirety.
     *
     * A copy of the backing buffer is returned.
     *
     * The base class implementation uses {@link get_bytes} to create the InputStream.  Subclasses
     * should look for more optimal implementations.
     */
static GByteArray* geary_memory_buffer_real_get_byte_array (GearyMemoryBuffer* self) {
	GByteArray* result = NULL;
	GByteArray* byte_array = NULL;
	GByteArray* _tmp0_ = NULL;
	GBytes* _tmp1_ = NULL;
	GBytes* _tmp2_ = NULL;
	gsize _tmp3_;
	guint8* _tmp4_ = NULL;
#line 66 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp0_ = g_byte_array_new ();
#line 66 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	byte_array = _tmp0_;
#line 67 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp1_ = geary_memory_buffer_get_bytes (self);
#line 67 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp2_ = _tmp1_;
#line 67 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp4_ = g_bytes_get_data (_tmp2_, &_tmp3_);
#line 67 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	g_byte_array_append (byte_array, _tmp4_, _tmp3_);
#line 67 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_g_bytes_unref0 (_tmp2_);
#line 69 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	result = byte_array;
#line 69 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return result;
#line 201 "memory-buffer.c"
}


GByteArray* geary_memory_buffer_get_byte_array (GearyMemoryBuffer* self) {
#line 65 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), NULL);
#line 65 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return GEARY_MEMORY_BUFFER_GET_CLASS (self)->get_byte_array (self);
#line 210 "memory-buffer.c"
}


/**
     * Returns an array of uint8 storing the buffer in its entirety.
     *
     * A copy of the backing buffer is returned.
     *
     * The base class implementation uses {@link get_bytes} to create the InputStream.  Subclasses
     * should look for more optimal implementations.
     *
     * @see UnownedBytesBuffer
     */
static guint8* _vala_array_dup3 (guint8* self, int length) {
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 227 "memory-buffer.c"
}


static guint8* geary_memory_buffer_real_get_uint8_array (GearyMemoryBuffer* self, int* result_length1) {
	guint8* result = NULL;
	GBytes* _tmp0_ = NULL;
	GBytes* _tmp1_ = NULL;
	gsize _tmp2_;
	guint8* _tmp3_ = NULL;
	guint8* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	guint8* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	guint8* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp0_ = geary_memory_buffer_get_bytes (self);
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp1_ = _tmp0_;
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp3_ = g_bytes_get_data (_tmp1_, &_tmp2_);
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup3 (_tmp3_, _tmp2_) : ((gpointer) _tmp3_);
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp4__length1 = _tmp2_;
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp5_ = _tmp4_;
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp5__length1 = _tmp4__length1;
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_g_bytes_unref0 (_tmp1_);
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp6_ = _tmp5_;
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp6__length1 = _tmp5__length1;
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	if (result_length1) {
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
		*result_length1 = _tmp6__length1;
#line 267 "memory-buffer.c"
	}
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	result = _tmp6_;
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return result;
#line 273 "memory-buffer.c"
}


guint8* geary_memory_buffer_get_uint8_array (GearyMemoryBuffer* self, int* result_length1) {
#line 82 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), NULL);
#line 82 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return GEARY_MEMORY_BUFFER_GET_CLASS (self)->get_uint8_array (self, result_length1);
#line 282 "memory-buffer.c"
}


/**
     * Returns a copy of the contents of the buffer as though it was a null terminated string.
     *
     * The base class implementation uses {@link get_bytes} to create the InputStream.  Subclasses
     * should look for more optimal implementations.
     *
     * No validation is made on the string.  See {@link get_valid_utf8}.
     *
     * @see UnownedStringBuffer
     */
static void _vala_array_add14 (guint8** array, int* length, int* size, guint8 value) {
#line 98 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	if ((*length) == (*size)) {
#line 98 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 98 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
		*array = g_renew (guint8, *array, *size);
#line 303 "memory-buffer.c"
	}
#line 98 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	(*array)[(*length)++] = value;
#line 307 "memory-buffer.c"
}


static gchar* geary_memory_buffer_real_to_string (GearyMemoryBuffer* self) {
	gchar* result = NULL;
	guint8* buffer = NULL;
	gint _tmp0_ = 0;
	guint8* _tmp1_ = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	guint8* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gchar* _tmp4_ = NULL;
#line 97 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp1_ = geary_memory_buffer_get_uint8_array (self, &_tmp0_);
#line 97 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	buffer = _tmp1_;
#line 97 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	buffer_length1 = _tmp0_;
#line 97 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_buffer_size_ = buffer_length1;
#line 98 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp2_ = buffer;
#line 98 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp2__length1 = buffer_length1;
#line 98 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_vala_array_add14 (&buffer, &buffer_length1, &_buffer_size_, (guint8) '\0');
#line 100 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp3_ = buffer;
#line 100 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp3__length1 = buffer_length1;
#line 100 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp4_ = g_strdup ((const gchar*) _tmp3_);
#line 100 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	result = _tmp4_;
#line 100 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	buffer = (g_free (buffer), NULL);
#line 100 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return result;
#line 349 "memory-buffer.c"
}


gchar* geary_memory_buffer_to_string (GearyMemoryBuffer* self) {
#line 96 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), NULL);
#line 96 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return GEARY_MEMORY_BUFFER_GET_CLASS (self)->to_string (self);
#line 358 "memory-buffer.c"
}


/**
     * Returns a copy of the contents of the buffer as though it was a UTF-8 string.
     *
     * The base class implementation uses {@link get_bytes} to create the InputStream.  Subclasses
     * should look for more optimal implementations.
     *
     * If the conversion fails or decodes as invalid UTF-8, an empty string is returned.
     *
     * @see UnownedStringBuffer.get_unowned_valid_utf8
     */
static gchar* geary_memory_buffer_real_get_valid_utf8 (GearyMemoryBuffer* self) {
	gchar* result = NULL;
	gchar* str = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp5_ = NULL;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp0_ = geary_memory_buffer_to_string (self);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	str = _tmp0_;
#line 116 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp2_ = str;
#line 116 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp3_ = g_utf8_validate (_tmp2_, (gssize) -1, NULL);
#line 116 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	if (_tmp3_) {
#line 390 "memory-buffer.c"
		const gchar* _tmp4_ = NULL;
#line 116 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
		_tmp4_ = str;
#line 116 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
		_tmp1_ = _tmp4_;
#line 396 "memory-buffer.c"
	} else {
#line 116 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
		_tmp1_ = "";
#line 400 "memory-buffer.c"
	}
#line 116 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_tmp5_ = g_strdup (_tmp1_);
#line 116 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	result = _tmp5_;
#line 116 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	_g_free0 (str);
#line 116 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return result;
#line 410 "memory-buffer.c"
}


gchar* geary_memory_buffer_get_valid_utf8 (GearyMemoryBuffer* self) {
#line 113 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), NULL);
#line 113 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return GEARY_MEMORY_BUFFER_GET_CLASS (self)->get_valid_utf8 (self);
#line 419 "memory-buffer.c"
}


GearyMemoryBuffer* geary_memory_buffer_construct (GType object_type) {
	GearyMemoryBuffer * self = NULL;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	self = (GearyMemoryBuffer*) geary_base_object_construct (object_type);
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return self;
#line 429 "memory-buffer.c"
}


gsize geary_memory_buffer_get_size (GearyMemoryBuffer* self) {
#line 28 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), 0UL);
#line 28 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return GEARY_MEMORY_BUFFER_GET_CLASS (self)->get_size (self);
#line 438 "memory-buffer.c"
}


gsize geary_memory_buffer_get_allocated_size (GearyMemoryBuffer* self) {
#line 33 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), 0UL);
#line 33 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	return GEARY_MEMORY_BUFFER_GET_CLASS (self)->get_allocated_size (self);
#line 447 "memory-buffer.c"
}


static void geary_memory_buffer_class_init (GearyMemoryBufferClass * klass) {
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	geary_memory_buffer_parent_class = g_type_class_peek_parent (klass);
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	((GearyMemoryBufferClass *) klass)->get_bytes = geary_memory_buffer_real_get_bytes;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	((GearyMemoryBufferClass *) klass)->get_input_stream = geary_memory_buffer_real_get_input_stream;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	((GearyMemoryBufferClass *) klass)->get_byte_array = geary_memory_buffer_real_get_byte_array;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	((GearyMemoryBufferClass *) klass)->get_uint8_array = geary_memory_buffer_real_get_uint8_array;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	((GearyMemoryBufferClass *) klass)->to_string = geary_memory_buffer_real_to_string;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	((GearyMemoryBufferClass *) klass)->get_valid_utf8 = geary_memory_buffer_real_get_valid_utf8;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_memory_buffer_get_property;
#line 468 "memory-buffer.c"
	/**
	     * Returns the number of valid (usable) bytes in the buffer.
	     */
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MEMORY_BUFFER_SIZE, g_param_spec_ulong ("size", "size", "size", 0, G_MAXULONG, 0UL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 474 "memory-buffer.c"
	/**
	     * Returns the number of bytes allocated (usable and unusable) for the buffer.
	     */
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MEMORY_BUFFER_ALLOCATED_SIZE, g_param_spec_ulong ("allocated-size", "allocated-size", "allocated-size", 0, G_MAXULONG, 0UL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 480 "memory-buffer.c"
}


static void geary_memory_buffer_instance_init (GearyMemoryBuffer * self) {
}


/**
 * Represents an interface to a variety of backing buffers.
 *
 * A Buffer may be an in-memory or on-disk block of bytes.  Buffer allows for a
 * uniform interface to these blocks and makes it easy to move them around and avoiding copies.
 *
 * Questions of mutability are left to the implementation and users of Buffer.  In general,
 * AbstractBuffers should be built and modified before allowing other callers to access it.
 *
 * @see ByteBuffer
 * @see EmptyBuffer
 * @see GrowableBuffer
 * @see StringBuffer
 * @see UnownedStringBuffer
 * @see UnownedBytesBuffer
 */
GType geary_memory_buffer_get_type (void) {
	static volatile gsize geary_memory_buffer_type_id__volatile = 0;
	if (g_once_init_enter (&geary_memory_buffer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearyMemoryBufferClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_memory_buffer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyMemoryBuffer), 0, (GInstanceInitFunc) geary_memory_buffer_instance_init, NULL };
		GType geary_memory_buffer_type_id;
		geary_memory_buffer_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyMemoryBuffer", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&geary_memory_buffer_type_id__volatile, geary_memory_buffer_type_id);
	}
	return geary_memory_buffer_type_id__volatile;
}


static void _vala_geary_memory_buffer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GearyMemoryBuffer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer);
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
	switch (property_id) {
#line 521 "memory-buffer.c"
		default:
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/memory/memory-buffer.vala"
		break;
#line 527 "memory-buffer.c"
	}
}



